{*******************************************************}
{                                                       }
{       Podstawy OpenGL w Delphi                        }
{       Wykorzystanie komponentu GlBox i OpenGL         }
{                                                       }
{       autor: Waldemara Pokuta - 2003                  }
{                                                       }
{*******************************************************}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  GLBox, OpenGL;

type
  TForm1 = class(TForm)
    GLBox1: TGLBox;
    procedure GLBox1Render(Sender: TObject);
    procedure GLBox1Resize(Sender: TObject);
    procedure GLBox1SetupRC(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.GLBox1SetupRC(Sender: TObject);
begin
  // Wartoci pocztkowe
  glClearColor(0, 0, 0, 1);
  GLBox1Resize(nil);
end;

procedure TForm1.GLBox1Resize(Sender: TObject);
begin
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity;
  glOrtho(-120, 120, -120, 120, -120, 120);
  glMatrixMode(GL_MODELVIEW);
end;

procedure TForm1.GLBox1Render(Sender: TObject);
var
  x, y, z, kat: real;
begin
  glClear(GL_COLOR_BUFFER_BIT);
  // punkt centralny
  glColor3f(1, 1, 1);
  glBegin(GL_POINTS);
    glVertex3f(0, 0, 0);
  glEnd;
  // strefa mocy
  glBegin(GL_POINTS);
    z := 40;
    kat := 0;
    while kat<=2*PI*3 do begin
      x := 70*sin(kat);
      y := 70*cos(kat);
      glVertex3f(x, y, z);
      z := z+0.1;
      kat := kat+0.2;
    end;
  glEnd;
end;

end.
